{
  Autor      : Michael Springwald
  Erstellt am: 03.05.2011
}

unit uplabspan;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, controls, ExtCtrls, Graphics,LCLType, LCLIntf;

type
  { TPLAbspan }
  TPLAbspan = class(TCustomControl)
  private

  protected

  public
    Timer:TTimer;
    StrList:TStringList;
    index, ph2, ScrollY, FirstLine,ScrollH:integer;
    isViewRect:Boolean;
    Buffer:TBitMap;
    isFillBuffer:Boolean;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure onTimer(Sender:TObject);
    procedure Paint; override;

    procedure Resize; override;

    procedure FillBuffer;

  published

  end; // TPLAbspan

implementation

{ TPLAbspan }
constructor TPLAbspan.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  isFillBuffer:=False;
  Buffer:=TBitMap.Create; ScrollH:=12;

  isViewRect:=False;
  index:=0; ph2:=0; ScrollY:=0; FirstLine:=0; ph2:=0;

  Timer:=TTimer.Create(self);
  Timer.OnTimer:=@onTimer;
  Timer.Interval:=30;
  Timer.Enabled:=False;
  StrList:=TStringList.Create;

  Canvas.Font.Size:=10;
  Canvas.Font.Name:='Ubuntu';
  Canvas.Font.Color:=clBlack;
end; // TPLAbspan.Create

destructor TPLAbspan.Destroy;
begin
  Buffer.Free; StrList.Free; Timer.Free;
  inherited Destroy;
end; // TPLAbspan.Destroy

procedure TPLAbspan.onTimer(Sender: TObject);
begin
  if ScrollH + 12 <=ClientHeight then inc(ScrollH,12);

  if ScrollY - 12 >=0 then
    ScrollY:=ScrollY-12
  else
    if isFillBuffer then
      Timer.Enabled:=False;
  Paint;
end; // TPLAbspan.onTimer

procedure TPLAbspan.Paint;
begin
  inherited Paint;
  if not isFillBuffer then begin
    FillBuffer;
    Canvas.Brush.Color:=clWhite;
  end;
  if Height-ScrollH > 0 then
  Canvas.FillRect(0,0,Width,Height-ScrollH);
  BitBlt(Canvas.Handle,0,Height-ScrollH,buffer.Width, ScrollH, Buffer.Canvas.Handle,0,ScrollY-2,SRCCOPY);

end;

procedure TPLAbspan.Resize;
begin
  inherited Resize;
end; // TPLAbspan.Resize

procedure TPLAbspan.FillBuffer;
var
  i,px,py,pw,ph:integer;
begin
  Buffer.Width:=Width;
  Buffer.Height:=Height;
  Buffer.Canvas.FillRect(0,0,buffer.Width, buffer.Height);

  Buffer.Canvas.Font.Size:=10;
  Buffer.Canvas.Font.Name:='Ubuntu';
  Buffer.Canvas.Font.Color:=clBlack;
  py:=0;

  for i:=0 to StrList.Count-1 do begin
    pw:=Buffer.Canvas.TextWidth(StrList[i]);
    ph:=Buffer.Canvas.TextHeight(StrList[i]);
    px:=Round((buffer.Width - pw) / 2);

    if py+ph >=Buffer.Height-ph then begin
      Buffer.Height:=Buffer.Height+ClientHeight;
      Buffer.Canvas.FillRect(0,py,ClientWidth,buffer.Height+ClientHeight+ph);
    end;
    Buffer.Canvas.TextOut(px,py,StrList[i]);
    inc(py,ph);
  end; // for i
  if StrList.Count-1 > 0 then isFillBuffer:=True;
  ScrollY:=Buffer.Height-ClientHeight;
  writeln(ScrollY);
end; // TPLAbspan.FillBuffer

end.

